import refreshTokenHelper from "../../../../../utils/refreshTokenHelper"
import forceLogoutHelper from "../../../../../utils/forceLogoutHelper"
import errorHandlingHelper from "../../../../../utils/errorHandlingHelper"

const handleFunc = async (event: any, authToken: any = null) => {
  let data: any = {}
  const config = useRuntimeConfig()
  const token = authToken ?? await getTokenHelper(event)
  const body = await readBody(event)

  if(body.name && body.seqNo) {
    const res: any = await event.context.fetch('models/r_status', 'POST', token, {
      AD_Org_ID: {
        id: body.organizationId,
        tableName: 'AD_Org'
      },
      R_StatusCategory_ID: {
        id: body.requestStatusCategoryId,
        tableName: 'R_StatusCategory'
      },
      isActive: body.isActive,
      name: body.name,
      isDefault: body.isDefault,
      isOpen: body.isOpen,
      isClosed: body.isClosed,
      value: body.value,
      timeoutDays: body.timeoutDays,
      isWebCanUpdate: body.isWebCanUpdate,
      isFinalClose: body.isFinalClose,
      seqNo: body.seqNo,
      description: body.description,
      help: body.help,
      tableName: 'R_Status'
    })
    if(res) {
      data = res
      data['status'] = 200
      data['message'] = ''
    }
  }

  return data
}

export default defineEventHandler(async (event) => {
  let data: any = {}

  try {
    data = await handleFunc(event)
  } catch(err: any) {
    try {
      let authToken: any = await refreshTokenHelper(event)
      data = await handleFunc(event, authToken)
    } catch(error: any) {
      data = errorHandlingHelper(err?.data ?? err, error?.data ?? error)
      forceLogoutHelper(event, data)
    }
  }

  return data
})